package org.bdware.mockjava;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;

public abstract class JsonVisitor {
    public JsonVisitor visit(JsonElement ele) {
        if (ele == null) return null;
        if (ele.isJsonArray()) {
            return visitJsonArray((JsonArray) ele);
        } else if (ele.isJsonObject()) {
            return visitObject(ele.getAsJsonObject());
        } else {
            JsonPrimitive primitive = ele.getAsJsonPrimitive();
            return visitPrimitive(primitive);
        }
    }

    public abstract JsonVisitor visitObject(JsonObject asJsonObject);

    public abstract JsonVisitor visitJsonArray(JsonArray ele);

    public abstract JsonVisitor visitPrimitive(JsonPrimitive primitive);

}
