package org.bdware.mockjava;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;

public class MockSchemaParser extends JsonVisitor {
    public static MockSchemaParser instance = new MockSchemaParser();
    JsonElement result;

    public JsonElement get() {
        return result;
    }

    @Override
    public JsonVisitor visitObject(JsonObject jsonObject) {
        JsonObject jo = new JsonObject();
        for (String key : jsonObject.keySet()) {
            JsonElement origin = jsonObject.get(key);
            visit(origin);
            JsonElement je = get();
            if (origin.isJsonArray()) {
                key += "|" + Math.min(((JsonArray) origin).size(), 20);
            }
            jo.add(key, je);
        }
        result = jo;
        return this;
    }

    @Override
    public JsonVisitor visitJsonArray(JsonArray array) {
         JsonArray ret = new JsonArray();
        if (array.size() > 0) {
            visit(array.get(0));
            ret.add(result);
        }
        result = ret;
        return this;
    }

    @Override
    public JsonVisitor visitPrimitive(JsonPrimitive primitive) {
        if (primitive.isBoolean()) {
            result = new JsonPrimitive("@boolean");
        } else if (primitive.isNumber()) {
            result = new JsonPrimitive("@integer");
        }
        result = new JsonPrimitive("@string");
        return this;
    }
}